/******************************************************************************
* File Name: ADC_DelSig_1_theACLK.h
* Version 1.0
*
*  Description:
*   Provides the function definitions for a clock component.
*
*
********************************************************************************
* Copyright 2008-2009, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/


#if !defined(CY_CLOCK_ADC_DelSig_1_theACLK_H)
#define CY_CLOCK_ADC_DelSig_1_theACLK_H

#include <CYTYPES.H>
#include <CYFITTER.H>


/***************************************
*        Function Prototypes            
***************************************/

void ADC_DelSig_1_theACLK_Start(void);
void ADC_DelSig_1_theACLK_Stop(void);
void ADC_DelSig_1_theACLK_StandbyPower(uint8 state);
void ADC_DelSig_1_theACLK_SetDivider(uint16 clkDivider);
void ADC_DelSig_1_theACLK_SetMode(uint8 clkMode);
void ADC_DelSig_1_theACLK_SetSource(uint8 clkSource);

#if defined(ADC_DelSig_1_theACLK__CFG3)
void ADC_DelSig_1_theACLK_SetPhase(uint8 clkPhase);
#endif


/* Backward compatibility macros for designs created with PSoC Creator 1.0 Beta 1 */
#define ADC_DelSig_1_theACLK_Enable ADC_DelSig_1_theACLK_Start
#define ADC_DelSig_1_theACLK_Disable ADC_DelSig_1_theACLK_Stop


/***************************************
*           API Constants        
***************************************/

/* Time values to delay the phase of an analog clock. */
#define CYCLK_2_5NS     		0x01 /* 2.5 ns delay. */
#define CYCLK_3_5NS     		0x02 /* 3.5 ns delay. */
#define CYCLK_4_5NS   			0x03 /* 4.5 ns delay. */ 
#define CYCLK_5_5NS   			0x04 /* 5.5 ns delay. */ 
#define CYCLK_6_5NS   			0x05 /* 6.5 ns delay. */ 
#define CYCLK_7_5NS   			0x06 /* 7.5 ns delay. */ 
#define CYCLK_8_5NS   			0x07 /* 8.5 ns delay. */ 
#define CYCLK_9_5NS   			0x08 /* 9.5 ns delay. */ 
#define CYCLK_10_5NS   			0x09 /* 10.5 ns delay. */
#define CYCLK_11_5NS   			0x0A /* 11.5 ns delay. */
#define CYCLK_12_5NS    		0x0B /* 12.5 ns delay. */
 

/***************************************
*             Registers        
***************************************/

/* Register to enable or disable the digital clocks */
#define ADC_DelSig_1_theACLK_CLKEN              ((reg8 *) ADC_DelSig_1_theACLK__PM_ACT_CFG)

/* Clock mask for this clock. */
#define ADC_DelSig_1_theACLK_CLKEN_MASK         ADC_DelSig_1_theACLK__PM_ACT_MSK

/* Register to enable or disable the digital clocks */
#define ADC_DelSig_1_theACLK_CLKSTBY            ((reg8 *) ADC_DelSig_1_theACLK__PM_STBY_CFG)

/* Clock mask for this clock. */
#define ADC_DelSig_1_theACLK_CLKSTBY_MASK       ADC_DelSig_1_theACLK__PM_STBY_MSK

/* Clock LSB divider configuration register. */
#define ADC_DelSig_1_theACLK_DIV_LSB            ((reg8 *) ADC_DelSig_1_theACLK__CFG0)

/* Clock MSB divider configuration register. */
#define ADC_DelSig_1_theACLK_DIV_MSB            ((reg8 *) ADC_DelSig_1_theACLK__CFG1)

/* Mode and source configuration register */
#define ADC_DelSig_1_theACLK_MOD_SRC            ((reg8 *) ADC_DelSig_1_theACLK__CFG2)

#if defined(ADC_DelSig_1_theACLK__CFG3)
/* Analog clock phase configuration register */
#define ADC_DelSig_1_theACLK_PHASE              ((reg8 *) ADC_DelSig_1_theACLK__CFG3)
#endif


/* CY_CLOCK_ADC_DelSig_1_theACLK_H */
#endif

