#include <device.h>
#include "LCD.h" 
#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "CyPins.h"

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
    #define FALSE 0
#endif

uint8 ISR_flag = 0;

/* Variable to store the Counter Status register. This value is used to find which is the cause of
 * Interupt (either Terminal Count or Capture event). The variable is updated inside the Counter ISR */
uint8 counter_status = 0;

/* Define to store the Frequency of the Clock used for the Counter component.
 * The value defined is in Hz */
#define CLOCK_FREQ (float)3000000

/* Define to indicate the number of microseconds in 1 second. Used for scaling purpose */
#define NO_OF_USEC 1000000


void main()
{

	int  result;
	float conv_result;
	float scale_f;
	char p_result[16];
	
	//int  result;
	//float conv_result;
	//float scale_f;
	//char p_result[16];
	float threshold = 2.00;
	
	//int  result;
	int i=0;
	//float conv_result;
	//float scale_f;
	//char p_result[16];
	char p_max[16],p_min[16],p_avg[16];
	float min,max,avg;
	int avgCount;
	
	int button;
//	uint8 ISR_flag = 0;
	
	
	//val 2
	uint16 counter_periodCount = 0;
    
				/* Variable to store the number of time the timer has overflown */
				uint16 counter_overflowCount = 0;
				
				/* This variable stored the period of the counter based on the period count and clock frequency value
				* The variable stores the caluclated period as float and in seconds */
				float counter_period_inSeconds = 0;
				
				/* The time measured between 2 events is stored in this variable. This variable is again a float because
				* of the precision required */
				float measuredTime = 0;
				
				/* Variable to store the count value that is captured at the instance of the rising edge of the
				* capture signal */
				uint16 capturedCount = 0;
				
				/* Variable stores the time derived from the captured count value */
				float capturedCountTime = 0;
				
				float measuredFreq = 0;
				
				char pFreq[16];

				//Counter_Start();
				//LCD_Start();
				//ISR_Counter_Start();
				
	avg = 0;
	min = 1.23;
	max = 0;
	avgCount = 1;
	
	
    
	
	
	if(CyPins_ReadPin(Pin_3_0))
	{
		button = 1;
	}
	
	if(CyPins_ReadPin(Pin_4_0))
	{
		button = 2;
	}
	
	if(CyPins_ReadPin(Pin_5_0))
	{
		button = 3;
	}
	
	if(CyPins_ReadPin(Pin_6_0))
	{
		button = 4;
	}
	
	switch(button)
	{
		
		case 1 :
		
		Counter_Start();
				LCD_Start();
				ISR_Counter_Start();
				
				LCD_Position(0,0);
				LCD_PrintString("Freq in Hz = ");
				
				/* Read the counter period count set in the configuration */
				counter_periodCount = Counter_ReadPeriod();
				
				/* Add one to counter_periodCount to include the count to reach 0. When the counter is
				* configured for e.g. 255 counts it will actually execute for 256 cycles*/
				/* Calculate the counter period. The value is stored in seconds */
				counter_period_inSeconds = (float)((uint32)counter_periodCount + 1) / CLOCK_FREQ;
				
				/* Enable the Global Interrupt */
				CYGlobalIntEnable;  
			
				for(;;)
				{
					/* Check if the Counter Interrupt has occurred */
					if (ISR_flag == TRUE)
					{
						/* Check if the Counter interrupt is caused by Terminal Count. This can be checked in the 
						* status register of the Counter. The Counter status register is read and the value is stored
						* in counter_status.
						* The defines Counter_STATUS_OVERFLOW_INT_EN_MASK and Counter_STATUS_CAPTURE_INT_EN_MASK can be
						* seen in Counter.h file.
						* These defines indicate the type of interrupt*/
						if ((counter_status & Counter_STATUS_OVERFLOW_INT_EN_MASK) == Counter_STATUS_OVERFLOW_INT_EN_MASK)
						{
							/* This checks if the interrupt is due to Terminal Count */
							/* Increment the counter_overflowCount. This variable keeps track of the number of times the
							* counter had overflown before the capture signal occurred. This count is used to calculate the
							* time when the capture occurs */
							counter_overflowCount++;
						}
						/* Check if the Counter interrupt is caused by Capture Event */
						if ((counter_status & Counter_STATUS_CAPTURE_INT_EN_MASK) == Counter_STATUS_CAPTURE_INT_EN_MASK)
						{
							/* This checks if the interrupt is due to Capture event */
							/* Read the value captured by the Counter on the rising edge of the capture signal */
							capturedCount = Counter_ReadCapture();
							
							/* Convert the captured count value into Time in seconds
							* Time = Captured count / Clock frequency of the counter */
							capturedCountTime = (float)(capturedCount + 1)/ CLOCK_FREQ;
							
							/* The counter is configured for "Reset on Capture" so that it resets automatically
							* and is ready for the next measurement */
							/* Calculate the total time between 2 events.
							* The measured time = (Number of times Counter Overflowed * Period of the Counter) +
							*                      The time measured using the capture count */
							measuredTime = (counter_overflowCount * counter_period_inSeconds) + capturedCountTime;
							
							measuredFreq = (float) (1/measuredTime);
							sprintf(pFreq,"%6.2f",measuredFreq);				/* Convert the measuredTime to microseconds */
							//measuredTime *= NO_OF_USEC;
							
							/* Reset the Overflow counter for the new measurement */
							counter_overflowCount = 0;
							
							/* Display the measured time on the display. The measuredTime is converted 
							* to Integer for the display */
							LCD_Position(1,0);
							//LCD_PrintInt16(HI16((uint32)measuredTime));
							//LCD_Position(1,3);
							//LCD_PrintInt16(LO16((uint32)measuredTime));
							//LCD_Position(1,8);
							LCD_PrintString(pFreq);
							//LCD_PrintString("Hz");
						}
						
						/* Clear the ISR_flag to indicate that the processing is done and the time has been measure */
						ISR_flag = FALSE;
						
					} /* End of "if" check for ISR_flag */
				
				} /* End of infinite "for" loop */
		
			break;
				
		case 2 :
		//FUNCTION NO.1 DISPLAY VOLTAGE
		
			LCD_Start();  
			LCD_Position(0, 0);    //Positions the cursor 
			LCD_PrintString("Voltage = ");//Prints the null terminated string Hello
			
			PGA_Start();
			ADC_DelSig_1_Start(); 
			ADC_DelSig_1_StartConvert(); 
			ADC_DelSig_1_IsEndConversion(ADC_DelSig_1_WAIT_FOR_RESULT); 
			result = ADC_DelSig_1_GetResult8();
			
			scale_f = (float)5/(float)256;
			
			conv_result = scale_f*(float)result;
			
			if(conv_result > -2.49 & conv_result < 0.00)
			{
				conv_result = conv_result + 5;
			}
			
			//sprintf(p_result,"%+1.4f",conv_result);
			
			//LCD_Position(1, 0);
			//LCD_PrintString(p_result);
			//LCD_PrintString("V");
			
			
		// FUNCTION NO. 2 PROBE	
			if(conv_result > threshold)
			{
			LCD_Position(1, 0); 
			LCD_PrintString(" High Voltage !!");   //Prints the value of I at (0,0)
			}
			else
			{
			LCD_Position(1, 0); 
			LCD_PrintString("Low Voltage..");   //Prints the value of I at (0,0)
			}
		 
 
				
				break;
				
		case 3 :
		
			// Voltage Averaging
			
			
		
		
			//SFRPRT1SEL |= 0x20;
			//SFRPRT1DR &= ~0x20;
			//SFRPRT1DR |= 0x20;
		
		
		
			LCD_Start();  
			LCD_Position(0, 0);    //Positions the cursor 
			
			
			PGA_Start();
			
			//uint8 Values;
			//Values = Pin_2_Read();
			ADC_DelSig_1_Start(); 
			
			while (CyPins_ReadPin(Pin_2_0))
				{
					ADC_DelSig_1_StartConvert(); 
					ADC_DelSig_1_IsEndConversion(ADC_DelSig_1_WAIT_FOR_RESULT); 
					result = ADC_DelSig_1_GetResult8();
			
					scale_f = (float)5/(float)256;
			
					conv_result = scale_f*(float)result;
			
						if(conv_result > -2.49999 & conv_result < 0.00)
							{
								conv_result = conv_result + 5;
							}
								//avg = conv_result;
								//min = conv_result;
								//max = conv_result;
								//avgCount = 1;
			
			
						if(conv_result > max)
								max = conv_result;
								else if(conv_result < min)
								min = conv_result;
					
						
				avg = ((avg*(float)avgCount) + conv_result)/(float)(++avgCount);
				
				sprintf(p_result,"%1.2f",conv_result);
				sprintf(p_max,"%1.2f",max);
				sprintf(p_min,"%1.2f",min);
				sprintf(p_avg,"%1.2f",avg);
			
				LCD_Position(0, 0);
				LCD_PrintString(p_result);
			
				LCD_Position(0, 6);
				LCD_PrintString(p_min);
			
				LCD_Position(1, 0);
				LCD_PrintString(p_max);
			
				LCD_Position(1, 6);
				LCD_PrintString(p_avg);
	
				}
		
				break;
				
		case 4 :
				
				//FUNCTION NO.1 DISPLAY VOLTAGE
		
			LCD_Start();  
			LCD_Position(0, 0);    //Positions the cursor 
			LCD_PrintString("Voltage = ");//Prints the null terminated string Hello
			
			PGA_Start();
			ADC_DelSig_1_Start(); 
			ADC_DelSig_1_StartConvert(); 
			ADC_DelSig_1_IsEndConversion(ADC_DelSig_1_WAIT_FOR_RESULT); 
			result = ADC_DelSig_1_GetResult8();
			
			scale_f = (float)5/(float)256;
			
			conv_result = scale_f*(float)result;
			
			
			if(conv_result > -2.49 & conv_result < 0.00)
			{
				conv_result = conv_result + 5;
			}
			sprintf(p_result,"%+1.4f",conv_result);
			
			LCD_Position(1, 0);
			LCD_PrintString(p_result);
			LCD_PrintString("V");
		
				
				/* Initialize the components */
				
				break;
}	
	
}	